;;;; type-checks-numbers.scm  -*- Scheme -*-
;;;; Kon Lovett, Jun '18

(module type-checks-numbers

(;export
  check-number
  check-positive-number check-natural-number check-negative-number check-non-positive-number
  check-fixnum
  check-positive-fixnum check-natural-fixnum check-negative-fixnum check-non-positive-fixnum
  check-flonum
  check-integer
  check-positive-integer check-natural-integer check-negative-integer check-non-positive-integer
  check-real
  check-complex
  check-rational
  check-exact
  check-inexact
  check-closed-interval check-open-interval
  check-half-closed-interval check-half-open-interval
  check-range)

(import scheme)
(import (chicken base))			; for `include'
(import (chicken type))
(import (chicken fixnum))
(import type-errors-numbers type-checks-basic)

(: check-number (* * #!optional * -> number))
(: check-positive-number  (* * #!optional * -> number ))
(: check-natural-number  (* * #!optional * -> number ))
(: check-negative-number  (* * #!optional * -> number ))
(: check-non-positive-number (* * #!optional * -> number))
(: check-fixnum (* * #!optional * -> fixnum))
(: check-positive-fixnum (* * #!optional * -> fixnum))
(: check-natural-fixnum  (* * #!optional * -> fixnum ))
(: check-negative-fixnum  (* * #!optional * -> fixnum ))
(: check-non-positive-fixnum (* * #!optional * -> fixnum))
(: check-flonum (* * #!optional * -> float))
(: check-integer (* * #!optional * -> integer))
(: check-positive-integer (* * #!optional * -> integer))
(: check-natural-integer (* * #!optional * -> integer))
(: check-negative-integer (* * #!optional * -> integer))
(: check-non-positive-integer (* * #!optional * -> integer))
(: check-real (* * #!optional * -> number))
(: check-complex (* * #!optional * -> cplxnum))
(: check-rational (* * #!optional * -> ratnum))
(: check-exact (* * #!optional * -> number))
(: check-inexact (* * #!optional * -> number))
(: check-closed-interval  (* number number number #!optional * -> number))
(: check-open-interval (* number number number #!optional * -> number))
(: check-half-closed-interval  (* number number number #!optional * -> number))
(: check-half-open-interval (* number number number #!optional * -> number))
(: check-range (* number number #!optional * -> number number))

(include "type-checks-numbers.impl.scm")

) ;module type-checks-numbers
