;;;; type-errors-numbers.scm  -*- Scheme -*-
;;;; Kon Lovett, Jul '18

(module type-errors-numbers

(;export
  ;
  error-range
  error-interval
  error-closed-interval error-open-interval
  error-half-open-interval error-half-closed-interval
  ;
  error-fixnum
  error-positive-fixnum error-natural-fixnum error-negative-fixnum error-non-positive-fixnum
  error-flonum
  error-complex
  error-rational
  ;
  error-number
  error-positive-number error-natural-number error-negative-number error-non-positive-number
  error-integer
  error-positive-integer error-natural-integer error-negative-integer error-non-positive-integer
  error-real
  ;
  error-exact
  error-inexact)

(import scheme)
(import (chicken base))
(import (chicken type))
(import (only (chicken string) conc))
(import type-errors-basic)

(: error-range (* number number #!optional * -> noreturn))
(: error-interval (* * * number number * #!optional * -> noreturn))
(: error-closed-interval (* * number number #!optional * -> noreturn))
(: error-open-interval (* * number number #!optional * -> noreturn))
(: error-half-open-interval (* * number number #!optional * -> noreturn))
(: error-half-closed-interval (* * number number #!optional * -> noreturn))
(: error-fixnum (* * #!optional * -> noreturn))
(: error-positive-fixnum (* * #!optional * -> noreturn))
(: error-natural-fixnum (* * #!optional * -> noreturn))
(: error-negative-fixnum (* * #!optional * -> noreturn))
(: error-non-positive-fixnum (* * #!optional * -> noreturn))
(: error-flonum (* * #!optional * -> noreturn))
(: error-number (* * #!optional * -> noreturn))
(: error-positive-number (* * #!optional * -> noreturn))
(: error-natural-number (* * #!optional * -> noreturn))
(: error-negative-number (* * #!optional * -> noreturn))
(: error-non-positive-number (* * #!optional * -> noreturn))
(: error-integer (* * #!optional * -> noreturn))
(: error-positive-integer (* * #!optional * -> noreturn))
(: error-natural-integer (* * #!optional * -> noreturn))
(: error-negative-integer (* * #!optional * -> noreturn))
(: error-non-positive-integer (* * #!optional * -> noreturn))
(: error-real (* * #!optional * -> noreturn))
(: error-complex (* * #!optional * -> noreturn))
(: error-rational (* * #!optional * -> noreturn))
(: error-exact (* * #!optional * -> noreturn))
(: error-inexact (* * #!optional * -> noreturn))

(include "type-errors-numbers.impl.scm")

) ;module type-errors-numbers
